#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=img\GeNi-End2End-Icon.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=GeNiEnd2End 4.6+ Performance Measure Test
#AutoIt3Wrapper_Res_Fileversion=0.5.0.2
#AutoIt3Wrapper_Res_FileVersion_AutoIncrement=y
#AutoIt3Wrapper_Res_LegalCopyright=NETCOR GmbH
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

; #INDEX# =======================================================================================================================
; Title .........: PerformanceMessung
; AutoIt ........: 3.3.6.1 oder neuer
; GeNiVersion....: 4.6+
; Language ......: Deutsch/Englisch
; Description ...: User Self Service GUI fr AdHoc Testing
; ===============================================================================================================================

#Region Includes and Options
#include-once
#include <Array.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <Constants.au3>
#include <GDIPlus.au3>
#include <GDIpProgress.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>

; Aus der USS
#include <IE.au3>
#include <INet.au3>
#include <String.au3>
#include <ProgressConstants.au3>
#include <EditConstants.au3>
#include <GuiComboBoxEx.au3>
;~ Opt("MustDeclareVars", 1)

Opt("WinTitleMatchMode", 2);Fenstererkennung 1=start, 2=subStr, 3=exact, 4=advanced, -1 to -4=Nocase
Opt("TCPTimeout", 100)

#EndRegion Includes and Options

#Region Editierbare Variablen
; Editierbare Variablen
Local Const $sGUIMeldungDefaultDe = "Testdauer ca. 60 Sek." ; Standart Meldung Deutsch
Local Const $sGUIMeldungDefaultEn = "Test duration ca. 60 Sek." ; Standart Meldung Deutsch
Local $sGUITitleDe = "Performance Messung" ; Default: Performance Messung - Testergebnisse
Local $sGUITitleEn = "Performance measure" ; Default: Performance measure - Results
Local $iGUIBorderWidth = 2 ; Wie breit soll der Rahmen sein? (In Pixeln) || Default: 2
Local $iGUIHeight = 180 ; Wie hoch soll das Fenster sein? (In Pixeln) || Default: 180
Local $iGUIWidth = 310 ; Wie breit soll das Fenster sein? (In Pixeln) || Default: 310
Local $iGUITitleMaxLength = 30 ; Wieviele Zeichen soll der Titel Maximal haben? || Default: 30

; Farben WICHTIG: HEX-FARBCODE NUTZEN! 0x vor dem Farbcode NICHT VERGESSEN!!!
Local $fGUIColorProgressBar = 0x666996 ; Farbcode fr den Fortschritsbalken || Default: 0x666996
Local $fGUIColorBG = 0xD2D2F8 ; Farbcode fr den Hintergrund || Default: 0xD2D2F8
Local $fGUIColorBorder = 0x1F204C ; Farbcode fr die Rahmen || Default: 0x1F204C
Local $fGUIColorMeasureGoodUp = 0x6BCC33 ; Farbcode fr den Balken (Oben). Testergebniss: Gut || Default: 0x6BCC33
Local $fGUIColorMeasureGoodDown = 0x59AC2A ; Farbcode fr den Balken (Unten). Testergebniss: Gut || Default: 0x59AC2A
Local $fGUIColorMeasureNormalUp = 0xe2da07 ; Farbcode fr den Balken (Oben). Testergebniss: Normal || Default: 0xe2da07
Local $fGUIColorMeasureNormalDown = 0xdf9b1b ; Farbcode fr den Balken (Unten). Testergebniss: Normal || Default: 0xdf9b1b
Local $fGUIColorMeasureBadUp = 0xff5555 ; Farbcode fr den Balken (Oben). Testergebniss: Schlecht || Default: 0xff5555
Local $fGUIColorMeasureBadDown = 0xff0000 ; Farbcode fr den Balken (Unten). Testergebniss: Schlecht || Default: 0xff0000
Local $fGUIColorProgressBarFont = 0xffffff ; Farbcode fr die Beschriftung in der ProgressBar || Default: 0xffffff
#EndRegion Editierbare Variablen

#Region Variablen
; Variablen
Local $hGUIBorderHeader
Local $hGUIBorderFooter
Local $hGUIBorderLeft
Local $hGUIBorderRight
Local $hGUIClose
Local $hGUIDisplay
Local $hGUIHeader
Local $hGUIHeaderIcon
Local $hGUIHeaderIconNew
Local $sGUIMeldung
Local $sGUIMeldungDefault
Local $sGUIMeldungTemp
Local $sGUIMeldungTestReady
Local $aGUIMouseOver
Local $sGUIMsg
Local $hGUIProgressBar
Local $hGUIProgressBarLabel
Local $iGUIProgressBarOnePercent = 1.666
Local $iGUIProgressBarPercent
Local $hGUIProgressBarStrichOben
Local $hGUIProgressBarStrichUnten
Local $hGUIProgressBarStrichLinks
Local $hGUIProgressBarStrichRechts
Local $hGUIStartButton
Local $hGUIStartButtonBmp
Local $hGUIStartButtonBmpNew
Local $bGUIStartHovered = False
Local $hGUITesttypButton
Local $hGUITesttypButtonBmp
Local $hGUITesttypButtonBmpNew
Local $bGUITesttypChecked = False
Local $hGUITesttypCombo
Local $sGUITesttypComboInput
Local $hGUITesttypDisplay
Local $hGUITesttypDisplayLegend
Local $bGUITesttypHovered = False
Local $sGUITitle
Local $hGUIZielendpunktButton
Local $hGUIZielendpunktButtonBmp
Local $hGUIZielendpunktButtonBmpNew
Local $bGUIZielendpunktChecked = False
Local $hGUIZielendpunktCombo
Local $hGUIZielendpunktComboInput
Local $hGUIZielendpunktDisplay
Local $hGUIZielendpunktDisplayLegend
Local $bGUIZielendpunktHovered
Local $bMessungdurchgelaufen = False
Local $iMessungProzent = 0
Local $bMessungProzentgeaendert = False
Local $sOS_Lang

; Inaktive Variablen
;~ Local $hGUIHeaderBG
;~ Local $hGUIProgressBarPixel
;~ Local $hGUIProgressBarPixelOnePercent
;~ Local $GUITesttypLabel
;~ Local $GUIZielendpunktLabel

; Neue und berprfen
Global $timetick = 10 ;Faktor fuer Wartezeit in den Schleifen. Standard ist 1, also eine Sekunde
Global $createLog = False
Local $tryConnTimeout = 0
Local $t_timeout = 30 ;default timeout
Local $sGUIMeldungold
#EndRegion Variablen

#Region Check
;Sprachauswahl ==> wenn die OS Sprache nicht deutsch ist, dann englisch
If @OSLang == "0407" Or @OSLang == "0807" Or @OSLang == "0c07" Or @OSLang == "1007" Or @OSLang == "1407" Then
;~ If False Then
	;0407; Deutschland
	;0807; Schweiz
	;0c07; sterreich
	;1007; Luxemburg
	;1407; Liechtenstein
	;Betriebssystemsprache Deutsch
	$sOS_Lang = "DE"
	$sGUIMeldungDefault = $sGUIMeldungDefaultDe
	$sGUITitle = $sGUITitleDe
Else
	;Betriebssystemsprache Englisch
	$sOS_Lang = "EN"
	$sGUIMeldungDefault = $sGUIMeldungDefaultEn
	$sGUITitle = $sGUITitleEn
EndIf
#EndRegion Check

#Region Start
#EndRegion Start

#Region GUI
_GDIPlus_Startup()

; Eincompilierung der Grafiken fr die Buttons
If $sOS_Lang = "DE" Then
	FileInstall("img/endpunkt.png", @TempDir & "/PMNETCORzielendpunkt.png", 1)
	FileInstall("img/testtyp.png", @TempDir & "/PMNETCORtesttyp.png", 1)
Else
FileInstall("img/location.png", @TempDir & "/PMNETCORzielendpunkt.png", 1)
FileInstall("img/testtype.png", @TempDir & "/PMNETCORtesttyp.png", 1)
EndIf
FileInstall("img/start.png", @TempDir & "/PMNETCORstart.png", 1)
FileInstall("img/GeNi-End2End-Icon16px.ico", @TempDir & "/PMNETCORGE2EICO.ico", 1)

; Erstelle das GUI
$hGUIDisplay = GUICreate($sGUITitle, $iGUIWidth, $iGUIHeight, -1, -1, $WS_POPUP)

GUICtrlSetColor($hGUIDisplay, $fGUIColorBorder) ; Schriftfarbe
GUISetBkColor($fGUIColorBG, $hGUIDisplay) ; Hintergrundfarbe fr das GUI

#Region GUI Border
; GUI Border
GUISetFont(-1, 2000)
$hGUIHeader = GUICtrlCreateLabel(" " & $sGUITitle, 19, $iGUIBorderWidth, 277, 15, 0, 0x100000)
$hGUIClose = GUICtrlCreateLabel("X", 295, $iGUIBorderWidth, 20, 15, 0, 0x100000)
$hGUIBorderHeader = GUICtrlCreateLabel("", 0, 0, $iGUIWidth, $iGUIBorderWidth, 0, 0x100000)
$hGUIBorderFooter = GUICtrlCreateLabel("", 0, $iGUIHeight - $iGUIBorderWidth, $iGUIWidth, $iGUIBorderWidth, 0, 0x100000)
$hGUIBorderLeft = GUICtrlCreateLabel("", 0, 0, $iGUIBorderWidth, $iGUIHeight, 0, 0x100000)
$hGUIBorderRight = GUICtrlCreateLabel("", $iGUIWidth - $iGUIBorderWidth, 0, $iGUIBorderWidth, $iGUIHeight, 0, 0x100000)
GUICtrlSetBkColor($hGUIHeader, $fGUIColorBorder) ; BGColor Titelleiste
GUICtrlSetBkColor($hGUIClose, $fGUIColorBorder) ; BGColor Schlieen X
GUICtrlSetBkColor($hGUIBorderHeader, $fGUIColorBorder) ; BGColor Border Header
GUICtrlSetBkColor($hGUIBorderFooter, $fGUIColorBorder) ; BGColor Border Foot
GUICtrlSetBkColor($hGUIBorderLeft, $fGUIColorBorder) ; BGColor Border Left
GUICtrlSetBkColor($hGUIBorderRight, $fGUIColorBorder) ; BGColor Border Right
;~ GUICtrlSetColor($hGUIHeader, $fGUIColorProgressBarFont) ; FontColor Titelleiste
GUICtrlSetColor($hGUIHeader, $fGUIColorBG) ; FontColor Titelleiste
GUICtrlSetColor($hGUIClose, $fGUIColorProgressBarFont) ; FontColor Schlieen X

; GeNiEnd2End-Icon oben Links
GUICtrlCreateLabel("", $iGUIBorderWidth, $iGUIBorderWidth, 17, 17, 0, 0x100000)
$hGUIHeaderIcon = _GDIPlus_ImageLoadFromFile(@TempDir & "/PMNETCORGE2EICO.ico")
$hGUIHeaderIconNew = _GDIPlus_GraphicsCreateFromHWND($hGUIDisplay)
GUIRegisterMsg($WM_PAINT, "MY_WM_PAINT")
GUISetFont(-1, 400, -1, -1)
#EndRegion GUI Border

#Region GUI Progress Bar
; Progress Bar
$hGUIProgressBar = _ProgressCreate(51, 101, 221, 24)
_ProgressSetText($hGUIProgressBar, $sGUIMeldung)
_ProgressSetColors($hGUIProgressBar, $fGUIColorProgressBar, $fGUIColorBorder, $fGUIColorBG, $fGUIColorProgressBar)
_ProgressSetFont($hGUIProgressBar, "", 9, 1, $fGUIColorProgressBarFont, 0)
$hGUIProgressBarStrichOben = GUICtrlCreateLabel("", 50, 100, 223, 1, 0)
$hGUIProgressBarStrichUnten = GUICtrlCreateLabel("", 50, 125, 223, 1)
$hGUIProgressBarStrichLinks = GUICtrlCreateLabel("", 50, 100, 1, 26)
$hGUIProgressBarStrichRechts = GUICtrlCreateLabel("", 272, 100, 1, 26)
GUICtrlSetBkColor($hGUIProgressBarStrichOben, $fGUIColorBorder)
GUICtrlSetBkColor($hGUIProgressBarStrichUnten, $fGUIColorBorder)
GUICtrlSetBkColor($hGUIProgressBarStrichLinks, $fGUIColorBorder)
GUICtrlSetBkColor($hGUIProgressBarStrichRechts, $fGUIColorBorder)
#EndRegion GUI Progress Bar

#Region GUI Buttons
; Start Button
$hGUIStartButton = GUICtrlCreateButton("Start", 10, 96, 32, 32, $BS_BITMAP)
$hGUIStartButtonBmp = _GDIPlus_BitmapCreateFromFile(@TempDir & "/PMNETCORstart.png")
If @OSBuild < 6000 Then
	$hGUIStartButtonBmpNew = ConvertBitmap($hGUIStartButtonBmp)
Else
	$hGUIStartButtonBmpNew = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hGUIStartButtonBmp)
EndIf
_GDIPlus_BitmapDispose($hGUIStartButtonBmp)
_WinAPI_DeleteObject(GUICtrlSendMsg($hGUIStartButton, $BM_SETIMAGE, $IMAGE_BITMAP, $hGUIStartButtonBmpNew))

; Testtyp Button
$hGUITesttypButton = GUICtrlCreateButton("Testtyp", 185, 25, 64, 45, $BS_BITMAP)
$hGUITesttypButtonBmp = _GDIPlus_BitmapCreateFromFile(@TempDir & "/PMNETCORtesttyp.png")
If @OSBuild < 6000 Then
	$hGUITesttypButtonBmpNew = ConvertBitmap($hGUITesttypButtonBmp)
Else
	$hGUITesttypButtonBmpNew = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hGUITesttypButtonBmp)
EndIf
_GDIPlus_BitmapDispose($hGUITesttypButtonBmp)
_WinAPI_DeleteObject(GUICtrlSendMsg($hGUITesttypButton, $BM_SETIMAGE, $IMAGE_BITMAP, $hGUITesttypButtonBmpNew))

; Zielendpunkt Button
$hGUIZielendpunktButton = GUICtrlCreateButton("Zielendpunkt", 60, 25, 64, 45, $BS_BITMAP)
$hGUIZielendpunktButtonBmp = _GDIPlus_BitmapCreateFromFile(@TempDir & "/PMNETCORzielendpunkt.png")
If @OSBuild < 6000 Then
	$hGUIZielendpunktButtonBmpNew = ConvertBitmap($hGUIZielendpunktButtonBmp)
Else
	$hGUIZielendpunktButtonBmpNew = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hGUIZielendpunktButtonBmp)
EndIf
_GDIPlus_BitmapDispose($hGUIZielendpunktButtonBmp)
_WinAPI_DeleteObject(GUICtrlSendMsg($hGUIZielendpunktButton, $BM_SETIMAGE, $IMAGE_BITMAP, $hGUIZielendpunktButtonBmpNew))
#EndRegion GUI Buttons

#Region GUI Dropdowns und TT&LE Anzeige
; Testtyp Dropdown
$hGUITesttypCombo = GUICtrlCreateCombo("", 50, 75, 224, 22, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL))
GUICtrlSetData($hGUITesttypCombo, "Video|Data", "VoIP")
GUICtrlSetState($hGUITesttypCombo, $GUI_HIDE)

; Zielendpunkt Dropdown
$hGUIZielendpunktCombo = GUICtrlCreateCombo("", 50, 75, 224, 22, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL))
GUICtrlSetData($hGUIZielendpunktCombo, "DC New York|DC Tokyo", "DC Hamburg")

GUICtrlSetState($hGUIZielendpunktCombo, $GUI_HIDE)

; Testtyp anzeige
If $sOS_Lang = "DE" Then
	$hGUITesttypDisplayLegend = GUICtrlCreateLabel("Testtyp:", 50, 135, 78, 15)
Else
	$hGUITesttypDisplayLegend = GUICtrlCreateLabel("Testtype:", 50, 135, 78, 15)
EndIf
$hGUITesttypDisplay = GUICtrlCreateLabel("...", 131, 135, 143, 15)
GUICtrlSetColor($hGUITesttypDisplayLegend, $fGUIColorBorder)
GUICtrlSetColor($hGUITesttypDisplay, $fGUIColorBorder)

; Zielendpunkt anzeige
If $sOS_Lang = "DE" Then
	$hGUIZielendpunktDisplayLegend = GUICtrlCreateLabel("Zielendpunkt:", 50, 155, 78, 15)
Else
	$hGUIZielendpunktDisplayLegend = GUICtrlCreateLabel("Location:", 50, 155, 78, 15)
EndIf
$hGUIZielendpunktDisplay = GUICtrlCreateLabel("...", 131, 155, 143, 15)
GUICtrlSetColor($hGUIZielendpunktDisplayLegend, $fGUIColorBorder)
GUICtrlSetColor($hGUIZielendpunktDisplay, $fGUIColorBorder)
#EndRegion GUI Dropdowns und TT&LE Anzeige

GUISetState()
#EndRegion GUI

#Region Hauptprogramm
;~ GUICtrlSetData($hGUITesttypCombo, $TestArrayComboString, $TestArrayTemp)
;~ GUICtrlSetData($hGUIZielendpunktCombo, $LocationArrayComboString, $LocationArrayTemp)

$sGUIMeldung = $sGUIMeldungDefault
_ProgressSetText($hGUIProgressBar, $sGUIMeldung)
AdlibRegister("_checkGUIClose", 2000)
AdlibRegister("_checkGUIMeldungchange", 50)

Do
	$sGUIMsg = GUIGetMsg()
	; Anzeige der aktuellen Einstellungen unter der Progressbar
	If $sGUITesttypComboInput <> GUICtrlRead($hGUITesttypCombo) Then
		$sGUITesttypComboInput = GUICtrlRead($hGUITesttypCombo)
		GUICtrlSetData($hGUITesttypDisplay, $sGUITesttypComboInput)
	EndIf
	If $hGUIZielendpunktComboInput <> GUICtrlRead($hGUIZielendpunktCombo) Then
		$hGUIZielendpunktComboInput = GUICtrlRead($hGUIZielendpunktCombo)
		GUICtrlSetData($hGUIZielendpunktDisplay, $hGUIZielendpunktComboInput)
	EndIf

#cs
	$temp = _GUICtrlComboBoxEx_GetListArray($hGUIZielendpunktCombo)
;~ $TestArrayCombo = _GUICtrlComboBoxEx_GetListArray($hGUIZielendpunktCombo)
	If $temp == $LocationArrayCombo Then
	Else
		GUICtrlSetData($hGUIZielendpunktCombo, "")
		GUICtrlSetData($hGUIZielendpunktCombo, $LocationArrayComboString, $LocationArrayTemp)
		ConsoleWrite("Location ungleich" & @CRLF)
		_ArrayDisplay($temp, "temp")
		_ArrayDisplay($LocationArrayCombo, "$LocationArrayCombo")
	EndIf

	$temp = _GUICtrlComboBoxEx_GetListArray($hGUITesttypCombo)
	If $temp == $TestArrayCombo Then
	Else
		GUICtrlSetData($hGUITesttypCombo, "")
		GUICtrlSetData($hGUITesttypCombo, $TestArrayComboString, $TestArrayTemp)
		ConsoleWrite("Testtyp ungleich" & @CRLF)
	EndIf
#ce

	If $bMessungdurchgelaufen = False Then ; Messung ist noch nicht durchgelaufen
		If $sGUIMeldung == "" Then $sGUIMeldung = $sGUIMeldungDefault
		Switch $sGUIMsg
			Case 0
				$aGUIMouseOver = GUIGetCursorInfo($hGUIDisplay)
				If Not IsArray($aGUIMouseOver) Then ContinueLoop
				_PMMausOver($aGUIMouseOver)
			Case $hGUIStartButton
				_PMStart()
			Case $hGUITesttypButton
				_PMButtonTesttyp()
			Case $hGUIZielendpunktButton
				_PMButtonZielendpunkt()
			Case $hGUIClose
				_PMClose()
			Case $GUI_EVENT_CLOSE
				_PMClose()
		EndSwitch
	Else ; Messung ist durchgelaufen
		$sGUIMeldungTemp = ""
		If $bMessungProzentgeaendert = False Then
;~ 			If $iMessungProzent > 100 Then $iMessungProzent = 33 ; Fr Demozwecke: Setze die Prozent wieder auf 33, wenn die Prozent ber 100 gehen
			Switch $iMessungProzent
				Case 0 To 33
					_ProgressSetColors($hGUIProgressBar, $fGUIColorMeasureBadUp, $fGUIColorMeasureBadDown, $fGUIColorBG, $fGUIColorProgressBar)
					If $sOS_Lang = "DE" Then
						$sGUIMeldungTestReady = "Result: Schlecht " & $iMessungProzent
					Else
						$sGUIMeldungTestReady = "Result: Bad " & $iMessungProzent
					EndIf
				Case 34 To 66
					_ProgressSetColors($hGUIProgressBar, $fGUIColorMeasureNormalUp, $fGUIColorMeasureNormalDown, $fGUIColorBG, $fGUIColorProgressBar)
					If $sOS_Lang = "DE" Then
						$sGUIMeldungTestReady = "Ergebniss: Normal " & $iMessungProzent
					Else
						$sGUIMeldungTestReady = "Result: Normal " & $iMessungProzent
					EndIf
				Case 66 To 100
					_ProgressSetColors($hGUIProgressBar, $fGUIColorMeasureGoodUp, $fGUIColorMeasureGoodDown, $fGUIColorBG, $fGUIColorProgressBar)
					If $sOS_Lang = "DE" Then
						$sGUIMeldungTestReady = "Ergebniss: Gut " & $iMessungProzent
					Else
						$sGUIMeldungTestReady = "Result: Good " & $iMessungProzent
					EndIf
			EndSwitch
			$bMessungProzentgeaendert = True
;~ 			GUICtrlSetData($hGUITesttypCombo, "")
;~ 			GUICtrlSetData($hGUITesttypCombo, $TestArrayComboString, $TestArrayTemp)
;~ 			GUICtrlSetData($hGUIZielendpunktCombo, "")
;~ 			GUICtrlSetData($hGUIZielendpunktCombo, $LocationArrayComboString, $LocationArrayTemp)
		EndIf
;~ 		If $bMessungProzentgeaendert = False Then
;~ 			GUICtrlSetData($hGUITesttypCombo, "")
;~ 			GUICtrlSetData($hGUITesttypCombo, $TestArrayComboString, $TestArrayTemp)
;~ 			GUICtrlSetData($hGUIZielendpunktCombo, "")
;~ 			GUICtrlSetData($hGUIZielendpunktCombo, $LocationArrayComboString, $LocationArrayTemp)
;~ 			$bMessungProzentgeaendert = True
;~ 		EndIf
		If $sGUIMeldung = "" Or $sGUIMeldung = $sGUIMeldungDefault Then $sGUIMeldung = $sGUIMeldungTestReady
		Switch $sGUIMsg
			Case 0
				$aGUIMouseOver = GUIGetCursorInfo($hGUIDisplay)
				If Not IsArray($aGUIMouseOver) Then ContinueLoop
				_PMMausOver($aGUIMouseOver)
			Case $hGUIStartButton
				_PMStart()
			Case $hGUITesttypButton
				_PMButtonTesttyp()
			Case $hGUIZielendpunktButton
				_PMButtonZielendpunkt()
			Case $hGUIClose
				_PMClose()
			Case $GUI_EVENT_CLOSE
				_PMClose()
		EndSwitch
	EndIf
;~ 	_ProgressSetText($hGUIProgressBar, $sGUIMeldung)
	Sleep(10)
Until $sGUIMsg = $GUI_EVENT_CLOSE

;Funktion _checkGUIClose deregistrieren
AdlibUnRegister("_checkGUIMeldungchange")
AdlibUnRegister("_checkGUIClose")

Exit
#EndRegion Hauptprogramm

#Region Funktionen
Func _PMButtonTesttyp() ; Zeige oder verstecke das Testtyp Drowpdown
	GUICtrlSetState($hGUIZielendpunktCombo, $GUI_HIDE)
	$bGUIZielendpunktChecked = False
	If Not $bGUITesttypChecked Then
		$bGUITesttypChecked = True
		GUICtrlSetState($hGUITesttypCombo, $GUI_SHOW)
	Else
		$bGUITesttypChecked = False
		GUICtrlSetState($hGUITesttypCombo, $GUI_HIDE)
	EndIf
	If $sOS_Lang = "DE" Then
		$sGUIMeldung = "Testtyp"
	Else
		$sGUIMeldung = "Testtype"
	EndIf
EndFunc   ;==>_PMButtonTesttyp

Func _PMButtonZielendpunkt() ; Zeige oder verstecke das Zielendpunkt Dropdown
	GUICtrlSetState($hGUITesttypCombo, $GUI_HIDE)
	$bGUITesttypChecked = False
	If Not $bGUIZielendpunktChecked Then
		$bGUIZielendpunktChecked = True
		GUICtrlSetState($hGUIZielendpunktCombo, $GUI_SHOW)
	Else
		$bGUIZielendpunktChecked = False
		GUICtrlSetState($hGUIZielendpunktCombo, $GUI_HIDE)
	EndIf
	If $sOS_Lang = "DE" Then
		$sGUIMeldung = "Zielendpunkt"
	Else
		$sGUIMeldung = "Location"
	EndIf
EndFunc   ;==>_PMButtonZielendpunkt

Func _PMMausOver($PMMOGUIMouseOver) ; Wird durch den Mausover aufgerufen und zeigt den Text an
	If $PMMOGUIMouseOver[4] = $hGUITesttypButton Then
		; Maus ber dem Testtyp Button
		If Not $bGUITesttypHovered Then
			If $sGUIMeldung <> $sGUIMeldungTemp Then $sGUIMeldungTemp = $sGUIMeldung
			$sGUITesttypComboInput = GUICtrlRead($hGUITesttypCombo)
			If $sOS_Lang = "DE" Then
				$sGUIMeldung = "Testtyp: " & $sGUITesttypComboInput
			Else
				$sGUIMeldung = "Testtype: " & $sGUITesttypComboInput
			EndIf
			$bGUITesttypHovered = True
		EndIf

	ElseIf $PMMOGUIMouseOver[4] = $hGUIZielendpunktButton Then
		; Maus ber dem Zielendpunkt Button
		If Not $bGUIZielendpunktHovered Then
			If $sGUIMeldung <> $sGUIMeldungTemp Then $sGUIMeldungTemp = $sGUIMeldung
			$hGUIZielendpunktComboInput = GUICtrlRead($hGUIZielendpunktCombo)
			If $sOS_Lang = "DE" Then
				$sGUIMeldung = "Zielendpunkt: " & $hGUIZielendpunktComboInput
			Else
				$sGUIMeldung = "Location: " & $hGUIZielendpunktComboInput
			EndIf
			$bGUIZielendpunktHovered = True
		EndIf
	ElseIf $PMMOGUIMouseOver[4] = $hGUIStartButton Then
		; Maus ber dem Start Button
		If Not $bGUIStartHovered Then
			If $sGUIMeldung <> $sGUIMeldungTemp Then $sGUIMeldungTemp = $sGUIMeldung
			If $sOS_Lang = "DE" Then
				$sGUIMeldung = "Starte die Messung (ca. 60 Sek.)"
			Else
				$sGUIMeldung = "Start the measure (ca. 60 Sek.)"
			EndIf
			$bGUIStartHovered = True
		EndIf
	Else
		; Kein Hover
		If $bGUITesttypHovered Or $bGUIZielendpunktHovered Or $bGUIStartHovered Then
			$sGUIMeldung = $sGUIMeldungTemp
			$bGUITesttypHovered = False
			$bGUIZielendpunktHovered = False
			$bGUIStartHovered = False
		EndIf
	EndIf
EndFunc   ;==>_PMMausOver

Func _PMStart() ; Beim Aufruf wird eine Messung durchgefhrt
	; Blende die Dropdowns wieder aus
	GUICtrlSetState($hGUITesttypCombo, $GUI_HIDE)
	GUICtrlSetState($hGUIZielendpunktCombo, $GUI_HIDE)
	$iGUIProgressBarPercent = 0
	_ProgressSetColors($hGUIProgressBar, $fGUIColorProgressBar, $fGUIColorBorder, $fGUIColorBG, $fGUIColorProgressBar)
	Do
	If $sOS_Lang = "DE" Then
	$sGUIMeldung = "%P%% Abgeschlossen"
	Else
	$sGUIMeldung = "%P%% finished"
	EndIf
	_ProgressSet($hGUIProgressBar, $iGUIProgressBarPercent)
	_ProgressSetText($hGUIProgressBar, $sGUIMeldung)
	$iGUIProgressBarPercent = $iGUIProgressBarPercent + 1
	Sleep(50)
	Until $iGUIProgressBarPercent >= 101
	$bMessungdurchgelaufen = True
	$bMessungProzentgeaendert = False
	$iMessungProzent = $iMessungProzent + 33
EndFunc   ;==>_PMStart

Func _PMClose() ; Beim Aufruf wird das Programm beendet
	AdlibUnRegister("_checkGUIMeldungchange")
	AdlibUnRegister("_checkGUIClose")
	_WinAPI_DeleteObject($hGUIStartButtonBmpNew)
	_WinAPI_DeleteObject($hGUITesttypButtonBmpNew)
	_WinAPI_DeleteObject($hGUIZielendpunktButtonBmp)
	GUIDelete($hGUIDisplay) ; Lsche das GUI
	_ProgressDelete($hGUIProgressBar) ; MUST BE DONE ON EXIT
	_Progress_CallBack_Free(1) ; Force Killing Timer
	_GDIPlus_Shutdown()

	$temp = 1
	While FileExists(@TempDir & "\PMNETCOR*.png") = True And $temp < 10
		$temp += $temp
;~ 		FileDelete(@TempDir & "\PMNETCORGE2EICO16px.png") ; Funktioniert zurzeit nicht
		FileDelete(@TempDir & "\PMNETCORstart.png")
		FileDelete(@TempDir & "\PMNETCORtesttyp.png")
		FileDelete(@TempDir & "\PMNETCORzielendpunkt.png")
		FileDelete(@TempDir & "\PMNETCORGE2EICO.ico") ; Funktioniert zurzeit nicht
	WEnd
	Exit
EndFunc   ;==>_PMClose

Func ConvertBitmap($hBitmap) ; Workaround fr WinXP
	Local $iButtonColor = _WinAPI_GetSysColor($COLOR_BTNFACE)
	$iButtonColor = 0x10000 * BitAND($iButtonColor, 0xFF) + BitShift($iButtonColor, 16) + BitAND($iButtonColor, 0x00FF00)
	Local $iWidth = _GDIPlus_ImageGetWidth($hBitmap), $iHeight = _GDIPlus_ImageGetHeight($hBitmap)
	Local $aResult = DllCall($ghGDIPDll, "uint", "GdipCreateBitmapFromScan0", "int", $iWidth, "int", $iHeight, "int", 0, "int", 0x0026200A, "ptr", 0, "int*", 0)
	Local $hBitmap_New = $aResult[6]
	Local $hCtx_new = _GDIPlus_ImageGetGraphicsContext($hBitmap_New)
	Local $hBrush = _GDIPlus_BrushCreateSolid(0xFF000000 + $iButtonColor)
	_GDIPlus_GraphicsFillRect($hCtx_new, 0, 0, $iWidth, $iHeight, $hBrush)
	_GDIPlus_GraphicsDrawImageRect($hCtx_new, $hBitmap, 0, 0, $iWidth, $iHeight)
	Local $hHBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hBitmap_New)
	_GDIPlus_BrushDispose($hBrush)
	_GDIPlus_BitmapDispose($hBitmap_New)
	_GDIPlus_GraphicsDispose($hCtx_new)
	Return $hHBitmap
EndFunc   ;==>ConvertBitmap

Func MY_WM_PAINT($hWnd, $msg, $wParam, $lParam) ; Draw PNG image
	_WinAPI_RedrawWindow($hGUIDisplay, 0, 0, $RDW_UPDATENOW)
	_GDIPlus_GraphicsDrawImage($hGUIHeaderIconNew, $hGUIHeaderIcon, 3, 3)
	_WinAPI_RedrawWindow($hGUIDisplay, 0, 0, $RDW_VALIDATE)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>MY_WM_PAINT


Func _checkGUIClose() ; Prft ob das GUI geschlossen werden soll. Wenn ja wird das Programm beendet.
	$msg = GUIGetMsg()
	Switch $msg
		Case $GUI_EVENT_CLOSE
			_PMClose()
		Case $hGUIClose
			_PMClose()
	EndSwitch
EndFunc   ;==>_checkGUIClose

Func _checkGUIMeldungchange() ; Prft ob die GUI Meldung sich gendert hat. Wenn ja wird sie bernommen.
	If $sGUIMeldungold = "" Then
		$sGUIMeldungold = $sGUIMeldung
	Else
		If StringLen($sGUIMeldung) >= 40 Then
			$sGUIMeldung = StringLeft($sGUIMeldung, 40) & "..."
		EndIf
		If $sGUIMeldung <> $sGUIMeldungold Then
			$sGUIMeldungold = $sGUIMeldung
			_ProgressSetText($hGUIProgressBar, $sGUIMeldung)
		EndIf
	EndIf
EndFunc   ;==>_checkGUIMeldungchange
#EndRegion Funktionen